// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v4.23.4
// source: bot.proto

package proto

import (
	context "context"
	proto "gitlab.com/nikita.morozov/ms-shared/proto"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// BotClient is the client API for Bot service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type BotClient interface {
	Create(ctx context.Context, in *BotModel, opts ...grpc.CallOption) (*proto.IdRequest, error)
	Update(ctx context.Context, in *BotModel, opts ...grpc.CallOption) (*emptypb.Empty, error)
	Delete(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*proto.BoolValue, error)
	Get(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*BotModel, error)
	List(ctx context.Context, in *proto.ListOptions, opts ...grpc.CallOption) (*BotListResp, error)
	Count(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*proto.UInt64Value, error)
}

type botClient struct {
	cc grpc.ClientConnInterface
}

func NewBotClient(cc grpc.ClientConnInterface) BotClient {
	return &botClient{cc}
}

func (c *botClient) Create(ctx context.Context, in *BotModel, opts ...grpc.CallOption) (*proto.IdRequest, error) {
	out := new(proto.IdRequest)
	err := c.cc.Invoke(ctx, "/botMs.Bot/Create", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *botClient) Update(ctx context.Context, in *BotModel, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/botMs.Bot/Update", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *botClient) Delete(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*proto.BoolValue, error) {
	out := new(proto.BoolValue)
	err := c.cc.Invoke(ctx, "/botMs.Bot/Delete", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *botClient) Get(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*BotModel, error) {
	out := new(BotModel)
	err := c.cc.Invoke(ctx, "/botMs.Bot/Get", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *botClient) List(ctx context.Context, in *proto.ListOptions, opts ...grpc.CallOption) (*BotListResp, error) {
	out := new(BotListResp)
	err := c.cc.Invoke(ctx, "/botMs.Bot/List", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *botClient) Count(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*proto.UInt64Value, error) {
	out := new(proto.UInt64Value)
	err := c.cc.Invoke(ctx, "/botMs.Bot/Count", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// BotServer is the server API for Bot service.
// All implementations must embed UnimplementedBotServer
// for forward compatibility
type BotServer interface {
	Create(context.Context, *BotModel) (*proto.IdRequest, error)
	Update(context.Context, *BotModel) (*emptypb.Empty, error)
	Delete(context.Context, *proto.IdRequest) (*proto.BoolValue, error)
	Get(context.Context, *proto.IdRequest) (*BotModel, error)
	List(context.Context, *proto.ListOptions) (*BotListResp, error)
	Count(context.Context, *emptypb.Empty) (*proto.UInt64Value, error)
	mustEmbedUnimplementedBotServer()
}

// UnimplementedBotServer must be embedded to have forward compatible implementations.
type UnimplementedBotServer struct {
}

func (UnimplementedBotServer) Create(context.Context, *BotModel) (*proto.IdRequest, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Create not implemented")
}
func (UnimplementedBotServer) Update(context.Context, *BotModel) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Update not implemented")
}
func (UnimplementedBotServer) Delete(context.Context, *proto.IdRequest) (*proto.BoolValue, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Delete not implemented")
}
func (UnimplementedBotServer) Get(context.Context, *proto.IdRequest) (*BotModel, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Get not implemented")
}
func (UnimplementedBotServer) List(context.Context, *proto.ListOptions) (*BotListResp, error) {
	return nil, status.Errorf(codes.Unimplemented, "method List not implemented")
}
func (UnimplementedBotServer) Count(context.Context, *emptypb.Empty) (*proto.UInt64Value, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Count not implemented")
}
func (UnimplementedBotServer) mustEmbedUnimplementedBotServer() {}

// UnsafeBotServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to BotServer will
// result in compilation errors.
type UnsafeBotServer interface {
	mustEmbedUnimplementedBotServer()
}

func RegisterBotServer(s grpc.ServiceRegistrar, srv BotServer) {
	s.RegisterService(&Bot_ServiceDesc, srv)
}

func _Bot_Create_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(BotModel)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(BotServer).Create(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.Bot/Create",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(BotServer).Create(ctx, req.(*BotModel))
	}
	return interceptor(ctx, in, info, handler)
}

func _Bot_Update_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(BotModel)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(BotServer).Update(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.Bot/Update",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(BotServer).Update(ctx, req.(*BotModel))
	}
	return interceptor(ctx, in, info, handler)
}

func _Bot_Delete_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(proto.IdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(BotServer).Delete(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.Bot/Delete",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(BotServer).Delete(ctx, req.(*proto.IdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Bot_Get_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(proto.IdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(BotServer).Get(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.Bot/Get",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(BotServer).Get(ctx, req.(*proto.IdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Bot_List_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(proto.ListOptions)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(BotServer).List(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.Bot/List",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(BotServer).List(ctx, req.(*proto.ListOptions))
	}
	return interceptor(ctx, in, info, handler)
}

func _Bot_Count_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(emptypb.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(BotServer).Count(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.Bot/Count",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(BotServer).Count(ctx, req.(*emptypb.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

// Bot_ServiceDesc is the grpc.ServiceDesc for Bot service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Bot_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "botMs.Bot",
	HandlerType: (*BotServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Create",
			Handler:    _Bot_Create_Handler,
		},
		{
			MethodName: "Update",
			Handler:    _Bot_Update_Handler,
		},
		{
			MethodName: "Delete",
			Handler:    _Bot_Delete_Handler,
		},
		{
			MethodName: "Get",
			Handler:    _Bot_Get_Handler,
		},
		{
			MethodName: "List",
			Handler:    _Bot_List_Handler,
		},
		{
			MethodName: "Count",
			Handler:    _Bot_Count_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "bot.proto",
}
